# Aashayein-Microservices

This is a demo project developed using microservice architecture focusing on user management and access control of users using Spring Security with OAuth2.

Implemented service layer for code modularity and business logic using Spring IOC and MySQL as database.

Developed the application using industry-standard design patterns like Singleton, Business Delegate, DAO, DTO, MVC, and Factory Pattern, etc for re-usability.

Hands-on experience with Spring Boot, Netflix OSS (Zuul, Eureka, Hystrix).

Implemented Zipkin for distributed Micro Service Monitoring. Zuul gateway for routing, authentication, and authorization.

Used spring config server for a centralized configuration where the configuration will pull from Github.

RabbitMQ is used as a messaging broker for sending mail.

Hands-on experience with build and deployment tools including Maven and Docker, logging and Debugging using Slf4 and Log4j.

Developed the code environment using IDE as STS-4 and deployed into Tomcat Server.



# Microservice Architecture Diagram


![Microservice Architecture](https://gitlab.com/microservices14/aashayein/Services/-/blob/master/documentation/Microservice%20Architecture.png)



# Config Server Architecture Diagram Integration With Git Webhook


![Config Server Architecture](https://gitlab.com/microservices14/aashayein/Services/-/blob/master/documentation/Config%20Server%20Architecture.png)


# Authentication Architecture Diagram Integration With OAuth2


![Authentication Architecture](https://gitlab.com/microservices14/aashayein/Services/-/blob/master/documentation/Authentication%20Architecture.png)



